﻿package  {
	
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.display.DisplayObjectContainer;
	import flash.display.MovieClip;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.geom.Matrix;
	import flash.geom.Point;
	import flash.geom.Rectangle;
	import flash.text.TextField;
	
	
	public class Jigsaw extends MovieClip {
		
		private var cubeArr:Array;		//用来存图块
		private var modelArr:Array;		//用来打乱图块顺序，为了保证有解，http://hanyeah.com/works/jigsaw.html
		private const IMG_W:Number=320;	//整张图宽
		private const IMG_H:Number=180;	//整张图高
		private var cubeW:Number;		//单个图块儿宽
		private var cubeH:Number;		//单个图块儿高
		private var w:int;				//图片切割行数
		private var h:int;				//图片切割列数
		private var gameCon:Sprite;		//游戏容器，盛放切割后的图片
		private var imgCon:Sprite;		//图片容器，盛放图片的缩略图
		private var bmd:BitmapData;		//图片数据
		// 周边四个点
		/**
		 *  □
		 * □○□
		 *  □
		 */
		private var neighbor:Array = [[ -1, 0], [1, 0], [0, -1], [0, 1]];
		
		private var pop:Sprite;//过关弹窗
		public function Jigsaw() {
			// constructor code
			// 如果是直接运行fla，一开始就有stage对象，就会直接调用initStage初始化；
			// 如果是被其他swf加载进去的，一开始没有stage对象，需要等待被加载到stage上之后再初始化。
			// 这句照抄就行，不用纠结。
			stage?initStage(null):addEventListener(Event.ADDED_TO_STAGE, initStage);
		}
		
		private function initStage(e:Event):void 
		{
			// 养成好习惯，事件执行之后remove掉，这样事件就只执行一次了。
			removeEventListener(Event.ADDED_TO_STAGE, initStage);
			//--------游戏容器
			bmd = new Bmd(); // fla里边有一张图，图片的链接是Bmd，创建这张图片的数据。（BitmapData只是图片的数据，并不是可以显示的图片）
			gameCon = new Sprite(); // 创建游戏的容器
			addChild(gameCon);
			gameCon.x = 10;
			gameCon.y = 10;
			gameCon.addChild(new Bitmap(bmd)); // Bitmap才是可以显示的图片。
			gameCon.graphics.lineStyle(1, 0xff0000, 1.0); // 设置线条颜色(红色,宽1像素)
			gameCon.graphics.drawRect( -1, -1, IMG_W + 3, IMG_H + 3);// 画个矩形
			//--------右下角的缩略图，同上
			imgCon = new Sprite();
			addChild(imgCon);
			imgCon.addChild(new Bitmap(bmd));
			imgCon.x = 10 + 320 + 30;
			imgCon.y = 130;
			imgCon.scaleX = imgCon.scaleY = 0.3;
			imgCon.graphics.lineStyle(1, 0xff0000, 1.0);
			imgCon.graphics.drawRect( -1, -1, IMG_W + 1, IMG_H + 1);
			//---------弹窗
			pop = new Sprite(); // 创建一个弹窗
			addChild(pop);
			pop.visible = false; // 默认不显示
			pop.buttonMode = true; // 鼠标放上去的时候变成小手
			// 画个矩形作为背景，黑色，半透明，和舞台尺寸一样，盖住整个舞台
			pop.graphics.beginFill(0x000000, 0.6);
			pop.graphics.drawRect(0, 0, stage.stageWidth, stage.stageHeight);
			pop.graphics.endFill();
			// 创建一个文本框
			var tf:TextField = new TextField();
			tf.textColor = 0xff0000;
			tf.x = 130;
			tf.y = 70;
			tf.name = "tf";
			pop.addChild(tf);
			tf.text = "恭喜过关\n点击重新开始";
			// 添加侦听，点击弹窗的时候，重新开始游戏
			pop.addEventListener(MouseEvent.CLICK, restartGame);
			
			//初始化游戏
			gameCon.addEventListener(MouseEvent.CLICK, click); // 等待用户点击游戏界面
			initGame(); // 初始化游戏
		}
		/**
		 * 点击图块儿
		 * 用户点击游戏界面时，执行这里
		 * @param	e
		 */
		private function click(e:MouseEvent):void 
		{
			var p1:Array = xy2ij(gameCon.mouseX,gameCon.mouseY); // 首先根据鼠标点击的位置，算出点的是哪个方块（第几行第几列）
			var ii:int = p1[0]; // 行
			var jj:int = p1[1]; // 列
			// trace(gameCon.mouseX,gameCon.mouseY, ii, jj); // 可以测试一线看看
			var p:Array = checkNeighbors(ii, jj); // trace(p1,p); // 查找点击的位置周边的空位置
			if (p) { // 如果有空位置
				changeCubeIJ(ii, jj, p[0], p[1]); // 将点击位置的图块和空白位置的图块交换位置（空白位置也有一个图块，只是看不到而已）
				checkWin(); // 检测是否拼好了。（每次移动之后都要检测一下是否拼好了）
			}
		}
		/**
		 * 点击pop重新开始
		 * @param	e
		 */
		private function restartGame(e:MouseEvent):void 
		{
			pop.visible = false; // 隐藏弹窗
			initGame(); // 初始化游戏
		}
		/**
		 * 游戏初始化
		 */
		private function initGame():void {
			clear(gameCon); // 清空游戏容器（那些小图快）
			w = 3; // 拼图的行数
			h = 2; // 拼图的列数
			cubeArr = new Array();
			modelArr = new Array();
			cubeW = IMG_W / w; // 图的宽度除以行数，就是每个小图快的宽度
			cubeH = IMG_H / h; // 图的宽度除以列数，就是每个小图快的高度
			// 初始化数据，比如3*2的拼图，初始化之后是[0,1,2,3,4,5]
			for (var i:int = 0; i < w;i++ ) {
				for (var j:int = 0; j < h;j++ ) {
					modelArr.push(i * h + j);
				}
			}
			// 打乱数据数组
			upsetArr();
			// 根据打乱的数据数组，设置图块的位置
			upsetCube();
			while (isWin()) { // 如果设置完成是拼好的，重新打乱，重新设置
				clear(gameCon);
				upsetArr();
				upsetCube();
			}
		}
		/**
		 * 打乱数组，保证有解
		 * 就是交换两个数的位置，交换几次之后，肯定是乱的，至于交换之后怎么保证拼图有解，参考：http://hanyeah.com/works/jigsaw.html
		 */
		private function upsetArr():void {
			var len:int = w * h;
			var i:int;
			var j:int;
			var ll:int = (len - 1) % 2 == 0?len - 1:len - 2;
			for (i = 0; i < ll;i++ ) {
				var ii:int = randomAB(0, len - 1);
				while (ii==i) {
					ii = randomAB(0, len - 1);
				}
				changeIJ(modelArr, i, ii);
			}
			//计算逆序数
			/*
			var inverseNum:int = 0;
			for (i = 0; i < len-1;i++ ) {
				var c:int = modelArr[i];
				for (j = i + 1; j < len - 1;j++ ) {
					if (c>modelArr[j]) {
						inverseNum++;
					}
				}
			}
			trace("逆序数："+inverseNum);
			*/
		}
		/**
		 * 根据数组切割并显示图块儿
		 */
		private function upsetCube():void {
			var len:int = w * h;
			var t:int = 0;
			for (var i:int = 0; i < w;i++ ) {
				cubeArr[i] = new Array();
				for (var j:int = 0; j < h;j++ ) {
					t = modelArr[i * h + j]; // 取打乱的数组中的值，如果不打乱，取的顺序应该是0、1、2、3...，打乱之后就是乱的了
					// 根据数组中取到的值，来选择图块
					var jj:int = t % h;
					var ii:int = int(t / h);
					var sp:Cube = createCube(bmd, cubeW, cubeH, -ii * cubeW, -jj * cubeH);
					// 把图块放在当前的行列上
					cubeArr[i][j] = sp;
					// 图块记录自己实际应该在的位置
					sp.idI = ii; 
					sp.idJ = jj;
					// 鼠标放到图块上变小受
					sp.buttonMode = true;
					// 设置图块的坐标
					sp.x = i * (cubeW + 1);
					sp.y = j * (cubeH + 1);
					// 添加显示
					gameCon.addChild(sp);
				}
			}
			cubeArr[w - 1][h - 1].visible = false;
		}
		/**
		 * 创建方块儿
		 * 从一张图片中，（offsetX，offsetY）的位置开始，截取一张宽高是（w,h）的图。
		 * @param	bmd
		 * @param	w
		 * @param	h
		 * @param	offsetX
		 * @param	offsetY
		 * @return
		 */
		private function createCube(bmd:BitmapData,w:Number,h:Number,offsetX:Number,offsetY:Number):Cube {
			var sp:Cube = new Cube();
			sp.graphics.beginBitmapFill(bmd, new Matrix(1, 0, 0, 1, offsetX, offsetY), false);
			sp.graphics.drawRect(0, 0, w, h);
			sp.graphics.endFill();
			return sp;
		}
		/**
		 * 移动方块儿，实际上是交换两个方块儿位置
		 * @param	i
		 * @param	j
		 * @param	ii
		 * @param	jj
		 */
		private function changeCubeIJ(i:int, j:int, ii:int, jj:int):void {
			// 交换两个图块在数组中的位置
			var t:Cube = cubeArr[i][j];
			cubeArr[i][j] = cubeArr[ii][jj];
			cubeArr[ii][jj] = t;
			// 交换之后，重新设置坐标
			cubeArr[i][j].x = i * (cubeW + 1);
			cubeArr[i][j].y = j * (cubeH + 1);
			cubeArr[ii][jj].x = ii * (cubeW + 1);
			cubeArr[ii][jj].y = jj * (cubeH + 1);
		}
		
		/**
		 * 步骤：检测是否拼好了
		 */
		private function checkWin():void {
			if (isWin()) { // 如果拼好了
				cubeArr[w - 1][h - 1].visible = true; // 显示最后一个图块
				pop.visible = true; // 显示结束弹窗
			}
		}
		
		/**
		 * 检测是否拼好了
		 * @return
		 */
		private function isWin():Boolean {
			// 遍历所有的图块
			for (var i:int = 0; i < w;i++ ) {
				for (var j:int = 0; j < h;j++ ) {
					if (cubeArr[i][j].idI!=i||cubeArr[i][j].idJ!=j) { // 如果发现“不在自己应该在的位置上的图块”，就没有拼好，返回false。
						return false;
					}
				}
			}
			// 遍历完了，没有发现“不在自己应该在的位置上的图块”，拼好了
			return true;
		}
		/**
		 * 检查ii，jj处的方块儿是否可移动
		 * @param	ii
		 * @param	jj
		 * @return
		 */
		private function checkNeighbors(ii:int,jj:int):Array {
			var iii:int;
			var jjj:int;
			for (var i:int = 0; i < neighbor.length; i++ ) {
				iii = ii + neighbor[i][0];
				jjj = jj + neighbor[i][1];
				if (cubeArr[iii]&&cubeArr[iii][jjj]&&cubeArr[iii][jjj].visible==false) {
					return [iii, jjj];
				}
			}
			return null;
		}
		/**
		 * xy坐标转化为位置索引ij
		 * @param	xx
		 * @param	yy
		 * @return
		 */
		private function xy2ij(xx:Number,yy:Number):Array {
			var ii:int = int(xx / (cubeW + 1));
			var jj:int = int(yy / (cubeH + 1));
			return [ii, jj];
		}
		/**
		 * 交换数组元素
		 * @param	arr
		 * @param	i
		 * @param	j
		 */
		private function changeIJ(arr:Array,i:int,j:int):void {
			var t = arr[i];
			arr[i] = arr[j];
			arr[j] = t;
		}
		/**
		 * 返回[a,b)区间内的整数
		 * @param	a
		 * @param	b
		 * @return
		 */
		private function randomAB(a:int,b:int):int {
			return int(Math.random() * (b - a) + a);
		}
		/**
		 * 清空容器
		 * @param	con
		 */
		private function clear(con:DisplayObjectContainer):void {
			while (con.numChildren) {
				con.removeChildAt(0);
			}
		}
	}
	
}
import flash.display.Sprite;
class Cube extends Sprite {
	public var idI:int;
	public var idJ:int;
	public function Cube() {
		
	}
}